% Sample for blinking LED on IO-Warrior 40

% Clear command screen
clc

disp('Sample for IO-Warrior 40')
disp('---------------------')

loadlibrary('iowkit.dll', @iowarrior, 'alias', 'iowkit');
if(libisloaded('iowkit'))
     
    handle = 0; % HANDLE
    
    % Open IO-Warrior
    disp('Open IO-Warrior')
    handle = calllib('iowkit', 'IowKitOpenDevice', handle);
 
    % Product IDs
    % IO-Warrior40      : INT 5376
    % IO-Warrior24      : INT 5377
    % IO-Warrior24PV    : INT 5393
    % OP-Warrior56      : INT 5379
    pid = calllib('iowkit', 'IowKitGetProductId', handle);
    
    if(pid == 5376)
        disp('Connected to IO-Warrior40')
        disp('Start writing 10 times')
        
        for m = 1:10
        
            % Generate random INTEGER for blink LEDs
            port = randi(255,1);

            fprintf('Write to Port 3: %d\n', port)
            
            % Write to IO-Warrior40
            reportID = 0;           % Report ID : 0 for IO-Ports
            reportByte0 = 255;      % Port 0
            reportByte1 = 255;      % Port 1
            reportByte2 = 255;      % Port 2
            reportByte3 = port;       % LED on port 3

            % Create report for writing
            Report= [reportID, reportByte0, reportByte1, reportByte2, reportByte3];
            pReport = libpointer('uint8Ptr', Report);

            % Write data to IO-Warrior
            % res: Bytes there be written
            res = calllib('iowkit', 'IowKitWrite', handle, 0, pReport, 8);
                        
            % Wait for 0.5 Seconds
            pause(0.5);
        end
    else
        disp('Wrong IO-Warrior !')
    end
    
    disp('---------------------')
    disp('Close IO-Warrior')
    %Close IO-Warrior DLL
    calllib('iowkit', 'IowKitCloseDevice', handle)
end

if(libisloaded('iowkit'))
    unloadlibrary('iowkit')
end


